import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'application' },
})
export class Application extends BaseModel {
  @prop({ required: false, index: true, zh: '报名的比赛id' })
  match_id: string;
  @prop({ required: false, index: true, zh: '报名比赛名称' })
  match_name: string;
  @prop({ required: false, index: true, zh: '团队id' })
  team_id: string;
  @prop({ required: false, index: true, zh: '所属管理员' })
  administrator: string;
  @prop({ required: false, index: true, zh: '团队名称' })
  team_name: string;
  @prop({ required: false, index: true, zh: '参赛人数' })
  num: string;
  @prop({ required: false, index: true, zh: '比赛成员id' })
  user_id: Array<any>;
  @prop({ required: false, index: false, zh: '报名时间' })
  apply_time: string;
  @prop({ required: false, index: true, zh: '分数' })
  score: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表:status',
    default: '0',
  })
  status: string;
}
