import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'course' },
})
export class Course extends BaseModel {
  @prop({ required: false, index: true, zh: '比赛id' })
  match_id: string;
  @prop({ required: false, index: false, zh: '比赛名称' })
  match_name: string;
  @prop({ required: false, index: true, zh: '红方团队id' })
  red_team_id: string;
  @prop({ required: false, index: true, zh: '红方团队名称' })
  red_team_name: string;
  @prop({ required: false, index: true, zh: '红方' })
  red_person: Array<any>;
  @prop({ required: false, index: true, zh: '红方分数', default: '0' })
  red_score: string;
  @prop({ required: false, index: true, zh: '蓝方团队id' })
  blue_team_id: string;
  @prop({ required: false, index: true, zh: '蓝方团队名称' })
  blue_team_name: string;
  @prop({ required: false, index: true, zh: '蓝方' })
  blue_person: Array<any>;
  @prop({ required: false, index: true, zh: '蓝方分数', default: '0' })
  blue_score: string;
  @prop({ required: false, index: false, zh: '比赛时间' })
  match_time: string;
  @prop({ required: false, index: false, zh: '胜者', default: '' })
  winner: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表：match_status',
    default: '0',
  })
  status: string;
}
