import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'match' },
})
export class Match extends BaseModel {
  @prop({ required: false, index: true, zh: '比赛名称' })
  name: string;
  @prop({ required: false, index: true, zh: '开始时间' })
  start_time: string;
  @prop({ required: false, index: true, zh: '结束时间' })
  end_time: string;
  @prop({ required: false, index: false, zh: '比赛地点' })
  address: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表:match_status',
    default: '0',
  })
  status: string;
  @prop({ required: false, index: false, zh: '报名截止时间' })
  sign_deadline: string;
  @prop({ required: false, index: false, zh: '比赛信息' })
  information: string;
}
