import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'team' },
})
export class Team extends BaseModel {
  @prop({ required: false, index: true, zh: '所属管理员' })
  administrator: string;
  @prop({ required: false, index: true, zh: '团队名称' })
  name: string;
  @prop({ required: false, index: true, zh: '成立时间' })
  create_time: string;
  @prop({ required: false, index: false, zh: '单位地址' })
  address: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: false, zh: '团队logo' })
  logo: Array<any>;
  @prop({ required: false, index: true, zh: '团队人数', default: 0 })
  number: number;
  @prop({ required: false, index: false, zh: '团队成员' })
  member: Array<any>;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表：status',
    default: '0',
  })
  status: string;
}
