import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import isString = require('lodash/isString');
@modelOptions({
  schemaOptions: { collection: 'user' },
})
export class User extends BaseModel {
  @prop({ required: false, index: true, zh: 'openid' })
  openid: string;
  @prop({
    required: false,
    index: true,
    zh: '类别',
    remark: '字典表：type用户类别：0：比赛人员，1：团队管理人员用户',
  })
  type: string;
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({ required: false, index: true, zh: '账号' })
  account: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: {
    secret: string;
  };
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: false, zh: '邮箱' })
  email: string;
  @prop({ required: false, index: false, zh: '性别', remark: '字典表：gender' })
  gender: string;
  @prop({ required: false, index: false, zh: '头像' })
  icon: Array<any>;
  @prop({ required: false, index: true, zh: '年龄' })
  age: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表：status',
    default: '0',
  })
  status: string;
  @prop({ required: false, index: false, zh: '工作单位' })
  work: string;
}
