import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_admin {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  'password': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
}

export class QDTO_admin extends SearchBase {
  constructor() {
    const like_prop = ['name'];
    const props = ['account', 'name'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
}

export class QVO_admin extends FVO_admin {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_admin {
  @ApiProperty({ description: '账号' })
  @Rule(RuleType['string']().allow('', null))
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  @Rule(RuleType['string']().allow('', null))
  'password': string = undefined;
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().allow('', null))
  'name': string = undefined;
}

export class CVO_admin extends FVO_admin {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_admin extends CDTO_admin {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().allow('', null))
  _id: string = undefined;
}

export class UVAO_admin extends FVO_admin {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
export class LoginVO {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = get(data, key);
    }
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
}

export class LoginDTO {
  @ApiProperty({ description: '账号', example: 'test' })
  @Rule(RuleType['string']().empty(''))
  'account': string = undefined;
  @ApiProperty({ description: '密码', example: '111111' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
}

export class ResetPasswordDTO {
  @ApiProperty({ description: '用户id', example: '' })
  @Rule(RuleType['string']().required())
  '_id': string = undefined;
  @ApiProperty({ description: '密码', example: '123456' })
  @Rule(RuleType['string']().required())
  'password': string = undefined;
}
