import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_application {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '报名的比赛id' })
  'match_id': string = undefined;
  @ApiProperty({ description: '报名比赛名称' })
  'match_name': string = undefined;
  @ApiProperty({ description: '所属管理员' })
  'administrator': string = undefined;
  @ApiProperty({ description: '团队id' })
  'team_id': string = undefined;
  @ApiProperty({ description: '团队名称' })
  'team_name': string = undefined;
  @ApiProperty({ description: '参赛人数' })
  'num': string = undefined;
  @ApiProperty({ description: '比赛成员id' })
  'user_id': Array<any> = undefined;
  @ApiProperty({ description: '报名时间' })
  'apply_time': string = undefined;
  @ApiProperty({ description: '分数' })
  'score': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_application extends SearchBase {
  constructor() {
    const like_prop = ['match_name', 'team_name'];
    const props = [
      'match_id',
      'match_name',
      'administrator',
      'team_id',
      'team_name',
      'num',
      'user_id',
      'score',
      'status',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '报名的比赛id' })
  'match_id': string = undefined;
  @ApiProperty({ description: '报名比赛名称' })
  'match_name': string = undefined;
  @ApiProperty({ description: '所属管理员' })
  'administrator': string = undefined;
  @ApiProperty({ description: '团队id' })
  'team_id': string = undefined;
  @ApiProperty({ description: '团队名称' })
  'team_name': string = undefined;
  @ApiProperty({ description: '参赛人数' })
  'num': string = undefined;
  @ApiProperty({ description: '比赛成员id' })
  'user_id': Array<any> = undefined;
  @ApiProperty({ description: '分数' })
  'score': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_application extends FVO_application {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_application {
  @ApiProperty({ description: '报名的比赛id' })
  @Rule(RuleType['string']().allow('', null))
  'match_id': string = undefined;
  @ApiProperty({ description: '报名比赛名称' })
  @Rule(RuleType['string']().allow('', null))
  'match_name': string = undefined;
  @ApiProperty({ description: '所属管理员' })
  @Rule(RuleType['string']().allow('', null))
  'team_id': string = undefined;
  @ApiProperty({ description: '团队id' })
  @Rule(RuleType['string']().allow('', null))
  'administrator': string = undefined;
  @ApiProperty({ description: '团队名称' })
  @Rule(RuleType['string']().allow('', null))
  'team_name': string = undefined;
  @ApiProperty({ description: '参赛人数' })
  @Rule(RuleType['string']().allow('', null))
  'num': string = undefined;
  @ApiProperty({ description: '比赛成员id' })
  @Rule(RuleType['array']().allow('', null))
  'user_id': Array<any> = undefined;
  @ApiProperty({ description: '报名时间' })
  @Rule(RuleType['string']().allow('', null))
  'apply_time': string = undefined;
  @ApiProperty({ description: '分数' })
  @Rule(RuleType['string']().allow('', null))
  'score': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().allow('', null))
  'status': string = undefined;
}

export class CVO_application extends FVO_application {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_application extends CDTO_application {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_application extends FVO_application {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
