import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_course {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '比赛id' })
  'match_id': string = undefined;
  @ApiProperty({ description: '比赛名称' })
  'match_name': string = undefined;
  @ApiProperty({ description: '红方团队id' })
  'red_team_id': string = undefined;
  @ApiProperty({ description: '红方团队名称' })
  'red_team_name': string = undefined;
  @ApiProperty({ description: '红方' })
  'red_person': Array<any> = undefined;
  @ApiProperty({ description: '红方分数' })
  'red_score': string = undefined;
  @ApiProperty({ description: '蓝方团队id' })
  'blue_team_id': string = undefined;
  @ApiProperty({ description: '蓝方团队名称' })
  'blue_team_name': string = undefined;
  @ApiProperty({ description: '蓝方' })
  'blue_person': Array<any> = undefined;
  @ApiProperty({ description: '蓝方分数' })
  'blue_score': string = undefined;
  @ApiProperty({ description: '比赛时间' })
  'match_time': string = undefined;
  @ApiProperty({ description: '胜者' })
  'winner': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_course extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'match_id',
      'red_team_id',
      'red_team_name',
      'red_person',
      'red_score',
      'blue_team_id',
      'blue_team_name',
      'blue_person',
      'blue_score',
      'status',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '比赛id' })
  'match_id': string = undefined;
  @ApiProperty({ description: '红方团队id' })
  'red_team_id': string = undefined;
  @ApiProperty({ description: '红方团队名称' })
  'red_team_name': string = undefined;
  @ApiProperty({ description: '红方' })
  'red_person': Array<any> = undefined;
  @ApiProperty({ description: '红方分数' })
  'red_score': string = undefined;
  @ApiProperty({ description: '蓝方团队id' })
  'blue_team_id': string = undefined;
  @ApiProperty({ description: '蓝方团队名称' })
  'blue_team_name': string = undefined;
  @ApiProperty({ description: '蓝方' })
  'blue_person': Array<any> = undefined;
  @ApiProperty({ description: '蓝方分数' })
  'blue_score': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_course extends FVO_course {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_course {
  @ApiProperty({ description: '比赛id' })
  @Rule(RuleType['string']().allow('', null))
  'match_id': string = undefined;
  @ApiProperty({ description: '比赛名称' })
  @Rule(RuleType['string']().allow('', null))
  'match_name': string = undefined;
  @ApiProperty({ description: '红方团队id' })
  @Rule(RuleType['string']().allow('', null))
  'red_team_id': string = undefined;
  @ApiProperty({ description: '红方团队名称' })
  @Rule(RuleType['string']().allow('', null))
  'red_team_name': string = undefined;
  @ApiProperty({ description: '红方' })
  @Rule(RuleType['array']().allow('', null))
  'red_person': Array<any> = undefined;
  @ApiProperty({ description: '红方分数' })
  @Rule(RuleType['string']().allow('', null))
  'red_score': string = undefined;
  @ApiProperty({ description: '蓝方团队id' })
  @Rule(RuleType['string']().allow('', null))
  'blue_team_id': string = undefined;
  @ApiProperty({ description: '蓝方团队名称' })
  @Rule(RuleType['string']().allow('', null))
  'blue_team_name': string = undefined;
  @ApiProperty({ description: '蓝方' })
  @Rule(RuleType['array']().allow('', null))
  'blue_person': Array<any> = undefined;
  @ApiProperty({ description: '蓝方分数' })
  @Rule(RuleType['string']().allow('', null))
  'blue_score': string = undefined;
  @ApiProperty({ description: '比赛时间' })
  @Rule(RuleType['string']().allow('', null))
  'match_time': string = undefined;
  @ApiProperty({ description: '胜者' })
  @Rule(RuleType['string']().allow('', null))
  'winner': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().allow('', null))
  'status': string = undefined;
}

export class CVO_course extends FVO_course {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_course extends CDTO_course {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_course extends FVO_course {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
