import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_match {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '比赛名称' })
  'name': string = undefined;
  @ApiProperty({ description: '开始时间' })
  'start_time': string = undefined;
  @ApiProperty({ description: '结束时间' })
  'end_time': string = undefined;
  @ApiProperty({ description: '比赛地点' })
  'address': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '报名截止时间' })
  'sign_deadline': string = undefined;
  @ApiProperty({ description: '比赛信息' })
  'information': string = undefined;
}

export class QDTO_match extends SearchBase {
  constructor() {
    const like_prop = ['name'];
    const props = ['name', 'start_time', 'end_time', 'status'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '比赛名称' })
  'name': string = undefined;
  @ApiProperty({ description: '开始时间' })
  'start_time': string = undefined;
  @ApiProperty({ description: '结束时间' })
  'end_time': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_match extends FVO_match {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_match {
  @ApiProperty({ description: '比赛名称' })
  @Rule(RuleType['string']().allow('', null))
  'name': string = undefined;
  @ApiProperty({ description: '开始时间' })
  @Rule(RuleType['string']().allow('', null))
  'start_time': string = undefined;
  @ApiProperty({ description: '结束时间' })
  @Rule(RuleType['string']().allow('', null))
  'end_time': string = undefined;
  @ApiProperty({ description: '比赛地点' })
  @Rule(RuleType['string']().allow('', null))
  'address': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().allow('', null))
  'status': string = undefined;
  @ApiProperty({ description: '报名截止时间' })
  @Rule(RuleType['string']().allow('', null))
  'sign_deadline': string = undefined;
  @ApiProperty({ description: '比赛信息' })
  @Rule(RuleType['string']().allow('', null))
  'information': string = undefined;
}

export class CVO_match extends FVO_match {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_match extends CDTO_match {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_match extends FVO_match {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
