import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_user {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: 'openid' })
  'openid': string = undefined;
  @ApiProperty({ description: '类别' })
  'type': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  'password': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '性别' })
  'gender': string = undefined;
  @ApiProperty({ description: '头像' })
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '年龄' })
  'age': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '工作单位' })
  'work': string = undefined;
}

export class QDTO_user extends SearchBase {
  constructor() {
    const like_prop = ['name'];
    const props = [
      'openid',
      'type',
      'name',
      'account',
      'phone',
      'age',
      'status',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: 'openid' })
  'openid': string = undefined;
  @ApiProperty({ description: '类别' })
  'type': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '年龄' })
  'age': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_user extends FVO_user {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_user {
  @ApiProperty({ description: 'openid' })
  @Rule(RuleType['string']().allow('', null))
  'openid': string = undefined;
  @ApiProperty({ description: '类别' })
  @Rule(RuleType['string']().allow('', null))
  'type': string = undefined;
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().allow('', null))
  'name': string = undefined;
  @ApiProperty({ description: '账号' })
  @Rule(RuleType['string']().allow('', null))
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  @Rule(RuleType['string']().allow('', null))
  'password': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().allow('', null))
  'phone': string = undefined;
  @ApiProperty({ description: '邮箱' })
  @Rule(RuleType['string']().allow('', null))
  'email': string = undefined;
  @ApiProperty({ description: '性别' })
  @Rule(RuleType['string']().allow('', null))
  'gender': string = undefined;
  @ApiProperty({ description: '头像' })
  @Rule(RuleType['array']().allow('', null))
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '年龄' })
  @Rule(RuleType['string']().allow('', null))
  'age': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().allow('', null))
  'status': string = undefined;
  @ApiProperty({ description: '工作单位' })
  @Rule(RuleType['string']().allow('', null))
  'work': string = undefined;
}

export class CVO_user extends FVO_user {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_user extends CDTO_user {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_user extends FVO_user {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
export class LoginVO {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = get(data, key);
    }
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: 'openid' })
  'openid': string = undefined;
  @ApiProperty({ description: '类别' })
  'type': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '性别' })
  'gender': string = undefined;
  @ApiProperty({ description: '头像' })
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '年龄' })
  'age': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '工作单位' })
  'work': string = undefined;
}

export class LoginDTO {
  @ApiProperty({ description: '账号', example: 'test' })
  @Rule(RuleType['string']().empty(''))
  'account': string = undefined;
  @ApiProperty({ description: '密码', example: '111111' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
}

export class ResetPasswordDTO {
  @ApiProperty({ description: '用户id', example: '' })
  @Rule(RuleType['string']().required())
  '_id': string = undefined;
  @ApiProperty({ description: '密码', example: '123456' })
  @Rule(RuleType['string']().required())
  'password': string = undefined;
}
