import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { Team } from '../entity/team.entity';
type modelType = ReturnModelType<typeof Team>;
@Provide()
export class TeamService extends BaseService<modelType> {
  @InjectEntityModel(Team)
  model: modelType;
  // 特殊查询 如果有用户信息 就在成员列表中查询
  async specialQuery(filter) {
    const { skip = 0, limit = 0, ...info } = filter;
    if (info.user) info.member = { $in: [info.user] };
    delete info.user;
    const data: any = await this.model.find(info).skip(skip).limit(limit);
    const total = await this.model.count(info);
    return { data, total };
  }
}
